Skip to main content

Changelog

Updates, changes, and improvements at Retool.

Refer to the stable and edge release notes for detailed information about self-hosted releases.

33 posts tagged with "Workflows"

View All Tags

Python runtime version selector and 3.14 availability

This feature is currently rolling out to cloud-hosted organizations and will be available in an upcoming self-hosted release.

You can now select the Python version used by a workflow from the Languages & Libraries tab. Click ... next to Python, select Update version, and choose between Python 3.10 and 3.14.

Python 3.14 does not include built-in libraries. When you upgrade, Retool automatically identifies any built-in libraries your workflow uses and installs them as custom libraries.

Delete workflows with the Retool API

You can now delete workflows programmatically using the DELETE /api/v2/workflows/{workflowId} endpoint in the Retool REST API.

To use this endpoint, your API token must have the workflows:write scope. The endpoint only supports deleting standard workflows—deleting agents and functions via the API is not supported.

Refer to the Retool API reference for full endpoint details, including request parameters and error responses.

Design update to workflows landing page

Retool made significant design updates to the workflows landing page to improve user experience and align more closely with the agents landing page.

The workflows landing page was updated for cloud instances. It will be available in an upcoming edge release, and is expected in the Q2 stable release for self-hosted instances. To revert to the previous landing page experience, toggle off the Reskin workflow index page to render agents home page UI feature flag in Settings > Beta.

The landing page displays all workflows, and folders containing workflows, for your Retool organization. You can perform the following actions from the landing page:

  • Sort workflows by Name, Last Updated date, or Created date.
  • Search for workflows.
  • Toggle between Grid view or Table view.
  • Refresh the workflows list.
  • Import a workflow from JSON.
  • Create a new Folder.
  • Create a new Workflow.
  • Create a workflow From Template.

Unpublish a workflow release

You can now unpublish workflow releases from the Releases tab.

This feature is also available for workflows protected with Source Control. When unpublishing a release on a protected workflow, the latest saved version on the main branch will be live to users.

Unpublish a workflow release

You can now unpublish workflow releases from the Releases tab.

Reach out to your account manager to enable unpublish for workflows.

This feature is also available for workflows protected with Source Control. When unpublishing a release on a protected workflow, the latest saved version on the main branch will be live to users.

Create README files for workflows

You can now create a README from the workflow IDE to help clarify important information about your workflow for collaborators. For example, if a workflow requires certain permissions on a resource, or if it's only scheduled to run once a week.

This feature is also available for workflows protected with Source Control. To create a README, click the title of the workflow and add content to the Editor README field. READMEs are visible from the Edit workflow details dialog box, in workflows JSON exports, and in a markdown file from source control.

Protected workflow triggers

Enterprise customers can now use Source Control to protect workflow triggers. This prevents changes to a workflow's triggers without review. When you protect a workflow for the first time, triggers are now automatically included.

To enable protected workflow triggers for self-hosted Retool on the stable channel, reach out to your Account Manager to enable the Allow users to edit triggers on branches feature flag.

For workflows that are already protected, you now have the option to protect triggers using a new PR.

Once protected, triggers are versioned and published alongside each release. Information about your triggers is stored in the startTrigger.yml file in your Source Control repository.

Result sync in Invoke Agent block

To enable Result (sync) for Agents in self-hosted Retool version 3.284.0 or 3.284.1, reach out to your account manager.

In version 3.284.2, Result (sync) for Agents is available by default, and admins can disable it in Settings > Beta by toggling the Agent blocks in workflows sync mode feature flag.

You can now see the output of an agent run with the Result (sync) return type when using the Invoke Agent block in workflows.

  • The Result (sync) type is the default setting. This returns the direct result of the agent's output.
  • The Run state (async) type returns the agentRunId, agentId, and status only. It does not include the output of the agent.

Code executor changes in self-hosted 3.251 and later

Self-hosted Retool 3.251 and later contain two notable changes to the code-executor service:

  • A container running code-executor is required to run workflows and custom API authentication. Previously, these features could be run in a sandbox in the backend container. Retool's security team has become aware of a sandbox escape and will no longer be supporting sandboxing in the backend. For more information refer to the disclosure page.
  • Traffic to the private 192.168.0.0/16 IP address range is blocked by default. If you want to disable this security configuration, follow the instructions in the code-executor security privileges documentation.

Protected workflows support manual releases

If you use Source Control to protect a workflow, you can now create and publish releases for that workflow. This allows you to safely test and build changes without disruption. Previously, protected workflows were automatically versioned and published, and you could not publish a specific version.

With this change, users must manually create a new release in order for their latest changes to be reflected in the live version of the workflow.

Once you merge a change into the main branch, navigate to the Releases tab in the left-hand menu. In this tab, you can create, manage, and publish versions of the workflow. Refer to Version and publish workflows for more information.